#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include "saeP1.h"
#include "../annexe/saeAnnexe.h"

//Partie Consultant.

void MenuUser(VilleIUT* lvIUT[],int tlogi)
{
    int intUserEntry=0;
    printf("#--------------------------------------------------------------------#\n");
    printf("|                                                                    |\n");
    printf("|                             SAE S1.02                              |\n");
    printf("|                                                                    |\n");
    printf("#--------------------------------------------------------------------#\n\n");
    printf("Codes correspondant aux différentes actions :\n\n");
    printf("1 : Rechercher les villes possèdant un IUT.\n");
    printf("2 : Afficher tout les départements de chaques IUT\n");
    printf("3 : Afficher le nombre de place en première année d'un IUT précis avec un département précis\n");
    printf("4 : Rechercher les IUTs possèdant un département précis.\n");
    printf("9 : Revenir à l'écran de sélection du profil.\n\n");
    printf("#--------------------------------------------------------------------#\n\n");
    while(intUserEntry!=9)
    {
        printf("Choisissez l'action que vous voulez exécuter : ");
        if (!(scanf("%d",intUserEntry)))printf("Entrée innexacte. Veuillez réessayer");
        if (intUserEntry==1) SearchCityWithIUT(VilleIUT* lvIUT[], int tlogi);
        if (intUserEntry==2) DepEachIUT(VilleIUT* lvIUT[], int tlogi);
        if (intUserEntry==3) SearchPlaceFromDepInIUT(VilleIUT* lvIUT[],int tlogi);
        if (intUserEntry==4) SearchIUTFromDep(VilleIUT* lvIUT[],int tlogi);
        if (intUserEntry==9) printf("Sortie en cours.\n");
        else printf("Entrée innexacte. Veuillez réessayer");
    }
}

void SearchCityWithIUT(VilleIUT* lvIUT[], int tlogi)
{
    for (int i=0;i<tlogi;++i) printf("%s",lvIUT[i]->Ville);
}

void DepEachIUT(VilleIUT* lvIUT[], int tlogi)
{
    for (int i=0;i<tlogi;++i)
    {
        printf("%s :",lvIUT[i]->Ville);
        MaillonDep* MaillonAct=lvIUT[i]->ldept;
        while (MaillonAct!=NULL) printf("\t-%s\n",MaillonAct->departement);
    }
}

void SearchPlaceFromDepInIUT(VilleIUT* lvIUT[],int tlogi)
{
    char sVille[31];
    char sDep[31];
    int boolF=0, i;
    printf("Entrez le nom de la ville contenant le département recherché :\n");
    scanf("%s",sVille);
    printf("Département y étant disponible :\n");
    for (i=0;i<tlogi;++i)
    {
        if (lvIUT[i]->Ville==sVille)
        {
            MaillonDep* MaillonAct=lvIUT[i]->ldept;
            while (MaillonAct!=NULL) printf("%s",MaillonAct->departement);
            boolF=1;
            MaillonAct=MaillonAct->suivant;
            break;
        }
    }
    if (!boolF)
    {
        printf("La ville n'est pas dans la liste.\nMerci de vérifier l'orthographe.\n");
        return;
    }
    printf("Entrez le nom du département dont vous souhaitez connaitre le nombre de place\n");
    scanf("%s",sDep);
    MaillonDep* MaillonAct=lvIUT[i]->ldept;
    while (MaillonAct!=NULL) 
    {
        
        if(MaillonAct->departement==sDep)
        {
            printf("Nombre de place : %d\n",MaillonAct->nbp);
            return;
        }
        MaillonAct=MaillonAct->suivant;
    }
    printf("Le département n'est pas dans la liste.\nMerci de vérifier l'orthographe.\n");
}

void SearchIUTFromDep(VilleIUT* lvIUT[],int tlogi)
{
    char sDep[31];
    printf("Merci de renseignez le département dont vous cherchez les IUTs :\n");
    scanf("%s",sDep);
    
    for (int i=0;i<tlogi;++i)
    {
        MaillonDep* MaillonAct=lvIUT[i]->ldept;
        if(MaillonAct->departement==sDep) printf("%s",lvIUT[i]->Ville);
    }
}

//Partie Administrateur.

void menuAdmin(VilleIUT* tiut[],int tlogi){
    printf("#--------------------------------------------------------------------#\n");
    printf("|                                                                    |\n");
    printf("|                             SAE S1.02                              |\n");
    printf("|                                                                    |\n");
    printf("#--------------------------------------------------------------------#\n\n");
    printf("Codes correspondant aux différentes actions :\n\n");
    printf("1 : Modifier le nombre de places dans un département.\n");
    printf("2 : Créer un département dans un IUT.\n");
    printf("3 : Supprimer un département d’un IUT.\n");
    printf("4 : Lancer et arrêter la phase de candidature.\n");
    printf("5 : Modifier le nom d'un responsable de département.\n");
    printf("9 : Revenir à l'écran de sélection du profil.\n\n");
    printf("#--------------------------------------------------------------------#\n\n");
    printf("Choisissez l'action que vous voulez exécuter : ");
    int act;
    scanf("%d",&act);
    switch(act){
		case 1:
			modifPlaces(tiut,int tlogi);
			reset();
			break;
		case 2:
			reset();
            break;
        case 3:
			reset();
			break;
		case 4:
			reset();
            break;
        case 5:
			reset();
			break;
		case 6:
			reset();
	}
}

void modifPlaces(VilleIUT* tiut{},int tlogi){
    printf("Entrez la ville correspondant à l'IUT à modifier (Q pour abandonner):");
    char* ville[31];
    scanf("%*c%s",&ville);
    if(ville=="Q") return;
    int noVille=rechercheTabPtVilleIUT(tiut,tlogi,ville);
    if(noVille<=0){
        fprintf(stderr,"Ville non existante !");
        return;
    }
    VilleIUT* v=tiut[noVille];
    printf("Entrez le département à modifier (Q pour abandonner):");
    char* dep[31];
    scanf("%*c%s",&dep);
    if(dep=="Q") return;
    if(!existe(tiut->ldept,dep)){
        fprintf(stderr,"Département non existant !");
        return;
    }
    MaillonDep* m=v->ldept
    for(int i=0; i<recherche(v->ldept,dep);i++){
        m=m->suivant;
    }
    printf("Il y a actuellement %d place(s) dans le département. A combien voulez-vous modifier ce nombre ?",m->nbp);
    int nPlaces;
    scanf("%d",&nPlaces);
    m->nbp=nPlaces;
    printf("Le nombre de places dans le département %s de l'IUT de %s a bien été modifié à %d place(s).",dep,ville,nPlaces);
    return;
}